
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>分布式数据库——从线性扩展谈分布式JOIN / iVAN</title>

    <meta name="description" content="分布式数据库——从线性扩展谈分布式JOIN 在首届阿里巴巴中间件峰会上,来自阿里巴巴DRDS团队的梦实分享了&lt;分布式数据库--从线性扩展谈分布式JOIN&gt;.他主要从OLTP数据库的线性扩展.水平扩容.IN查询.分布式JOIN四个方面进行了分享.在分享中,他主要通过买家与订单场景.家庭与孩子场景介绍了IN查询,通过同维度的JOIN.广播表的JOIN.Nested Loop Join详细介绍了分布式JOIN的坑与填坑.   以下内容根据直播视频整理而成.   在数据库的使用过程中,我们难免会问到这样的问题,为什么分库分表?答案是为 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">分布式数据库——从线性扩展谈分布式JOIN</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>在首届阿里巴巴中间件峰会上，来自阿里巴巴DRDS团队的梦实分享了《分布式数据库——从线性扩展谈分布式JOIN》。他主要从OLTP数据库的线性扩展、水平扩容、IN查询、分布式JOIN四个方面进行了分享。在分享中，他主要通过买家与订单场景、家庭与孩子场景介绍了IN查询，通过同维度的JOIN、广播表的JOIN、Nested<br />
Loop Join详细介绍了分布式JOIN的坑与填坑。</p>
<p> </p>
<p>以下内容根据直播视频整理而成。</p>
<p> </p>
<p>在数据库的使用过程中，我们难免会问到这样的问题，为什么分库分表？答案是为了达到线性扩展。在本次分享中，我们能够知道分布式数据库中线性扩展的含义，学会判定一个系统与查询能否达到线性扩展的目的，达到使用分布式数据库的目标。</p>
<h1><b>OLTP</b><b>数据库的线性扩展</b></h1>
<p>数据库主要有两类：OLAP数据库，SQL一般比较复杂，执行时间可能在秒级至分钟级，响应时间越快越好（单SQL占据更多的资源，例如Map Reduce模型），提供尽可能高的并发度；OLTP数据库，SQL一般比较简单，执行时间一般在毫秒级，响应时间在可接受范围（例如10ms）内即可（单SQL一般只有一个线程执行），提供尽可能高系统容量。</p>
<p>对于OLTP，来说，是否机器越多，SQL执行越快？答案是否定的。对于OLTP数据库中的线性扩展，增加机器数，单SQL的响应时间基本不会发生太大变化；增加机器数，能线性增加整个系统的容量（并发度、吞吐量、TPS）。并且，<b>在资源一定的情况下，从单机到分布式并不能带来更高的系统容量。</b></p>
<h1><b>水平扩容</b></h1>
<p>比如做一个全表的count（*）操作，每个分库上的时间可能是10ms，如果不带拆分键的话则需要到所有的表上去执行一个count（*）操作，如果将这些SQL并行的发下去，则会发现查询也只消耗了10ms的时间，与只在一个分库上执行的时间差不多。那为什么还要带拆分键？</p>
<p>比如我们有两台DB实例，如果带拆分键的话，往分布式数据库里面提交一个查询，到DB这边也是一个查询，那么提交6条查询之后，系统容量是6QPS。我们把提交到分布式数据库中的查询称为逻辑查询，把分布式数据库到底层所执行的查询称为物理查询。对于业务来说，分布式数据库是相对透明的，它关注的容量指的是逻辑QPS。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2E2MTZkOWEyYTExYTk3NzI0NmIzMTMzZjJlNzlhYWRlNGFjYzVkMTYucG5n.jpg"></p>
<p>发现系统容量不够时，需要进行扩容，我们需要加1台DB，成本提升了50%。如图所示，性能确实提高了50%。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2U1YmM2YWMwMjI4MGJjODYwOTE5MzVjMTc4NmE0MzRhNjA5NDI4ZjkucG5n.jpg"></p>
<p>假如我们的SQL没有带拆分键，那么它需要路由到所有的分片上去执行。一条逻辑SQL会生成2条物理SQL。扩容之后，成本提升了50%，一条逻辑SQL会生成3条物理SQL，系统性能也没有变化。所以得出一个结论：系统一定要带拆分键，否则没有可扩展性。</p>
<h1><b>IN</b><b>查询</b></h1>
<h2><b>买家与订单场景</b></h2>
<p>具体场景是：提供一个买家的所有订单ID，查出这些订单的信息，订单表按照订单ID进行拆分，SELECT * FROM ORDER WHERE ORDER_ID IN (?,?,?,?...)，假设单DB容量是1000QPS。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2NjMWVjYTE3YjdmMDMxYjg1NGQxOTExMTY0MjNjYzc4ZjRjOTBjOGUucG5n.jpg"></p>
<p>比如，2005年数据分片数为16，平均一个买家的订单数：2，IN查询涉及的分片数：期望值接近2，系统容量：16*1000/2=8000。到了2015年，数据分片数为64，平均一个买家的订单数：200，IN查询涉及的分片数：期望值接近64≈全表扫描，系统容量：64*1000/64=1000。在这种场景下，IN查询不具备线性扩展能力。</p>
<h2><b>家庭与孩子场景</b></h2>
<p>具体场景是：提供一个家庭的所有孩子ID，查出这些孩子的信息，孩子表按照孩子ID进行拆分，SELECT * FROM CHILD WHERE CHILD_ID IN (?,?)，假设单DB容量是1000QPS。跟前面的区别在于，订单数会随着时间的推移飞速发展，但是孩子数不会随着时间发生太明显的变化。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2NkZDk1ZjcwMTc4OGY0YjFmNzFlMmY2YTg3MjAyZDY5MmI5MWExYzQucG5n.jpg"></p>
<p>假设，2005年，数据分片数：16，平均一个家庭的孩子数：1-2，IN查询涉及的分片数：期望值接近2，系统容量：16*1000/2=8000。2015年，数据分片数：64，平均一个家庭的孩子数：1-2，IN查询涉及的分片数：期望值接近2，系统容量：64*1000/2=32000。在这种情况下，成本提升了50%，系统容量也提升了50%，IN查询实现了线性扩展。</p>
<h2><b>线性扩展</b></h2>
<p>对IN查询来说，必须满足下述条件才能做到线性扩展：IN的值的数目远远小于分片数；一般情况下，IN的值的数目在2-3个；IN的值的数目不会随着业务的发展而增长。相反的，只要有一条不满足，那么IN查询就无法做到线性扩展。</p>
<h1><b>分布式JOIN</b></h1>
<p>分布式JOIN有很多种情况，主要分为两大类：可下推的JOIN，JOIN操作由存储完成，DRDS层针对JOIN的结果进行处理，效率会高一些，因为存储和计算在一起；不可以下推的JOIN，存储层只做单表的查询，DRDS完成JOIN的操作。</p>
<p><b>同维度的JOIN</b></p>
<p>可下推的JOIN中很重要的是同维度的JOIN，JOIN的两个表是按照拆分键做的JOIN，简单例子如下：</p>
<pre><code>SELECT* FROM
user JOIN user_address
ON user.user_id= user_address.user_id</code></pre>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzg1ZmQ4YTUwMjFjY2U1ZjA0YWNiYzMyYzU5MTIwYzU0OWI3NzYwOGYucG5n.jpg"></p>
<p>user与user_address需要JOIN，并且均以user_id为拆分键。这样的结果是，对于同一个用户，其地址与它在同一个分片内。所以只需要在存储层把JOIN做好就可以了。对于DRDS来说，这个JOIN操作由下面的MySQL或者RDS来完成。DRDS层只需要把JOIN结果返回去就可以了。这种JOIN线性判断的标准是与单表SQL相同。</p>
<h2><b>广播表的JOIN</b></h2>
<p>另外一个比较常用的JOIN是广播表的JOIN。有些表具有以下特点：比较小，总会与其他表进行关联，这时候就不适合将其放在其中一个库上面，那么，这个JOIN就没有办法下推了。广播表是指所有分片中都存在一个完整的副本，一般用于变更比较少，容量比较小，需要频繁与其表发生关联的表。一张拆分表JOIN一张广播表的简单例子如下：</p>
<pre><code>SELECT* FROM
user JOIN user_address
ON user.user_id= user_address.user_id</code></pre>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ZkOWVlNmFhZjllMWI1MGNmMjdhZDFmZWExYTA4MzFjNGUwYzA4OWYucG5n.jpg"></p>
<p>此时，选择把level表作为广播表复制到每一个分片上去，这样的JOIN也可以做下推，只要做分片内的JOIN就可以了。这样一个查询的线性判断标准与单表SQL相同，由拆分表上的查询决定。</p>
<h2><b>Nested Loop Join</b></h2>
<p>Nested<br />
Loop Join是不可下推的分布式JOIN。具体例子如下：</p>
<pre><code>SELECT* FROM
order JOIN user
ON order.buyer_id=user.user_id</code></pre>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2M1YTBmMWRiNDI5ZGJlOTQzZjFjNGM2MGE2ZDUzYjA2ZDZkOTRiMmEucG5n.jpg"></p>
<p>user以user_id为拆分键，order（订单）以order_id为拆分键。JOIN不能由存储来完成，只能由DRDS层完成。具体的算法等价于在左表把需要的数据拿出来然后再去右表做应用查询，即以小表驱动（经过WHERE条件过滤后数据量较少的表为小表）。</p>
<p>对于这种JOIN，线性判断标准直观来说是对两个表的查询均需要能够线性。即对驱动表的判断与单表查询相同；对被驱动表的判断：被驱动表的JOIN列是否是拆分键，被驱动表做的IN查询的数目。</p>
<h2><b>实例分析</b></h2>
<p>主要有两张表，order表拆分键为order_id，user表拆分键为User_id。</p>
<p><b>SELECT* FROM order JOIN<br />
user ON order.buyer_id = user.user_id</b></p>
<p>结果分析：两张表均是全表扫描。</p>
<p><b>SELECT* FROM order JOIN<br />
user ON order.buyer_id = user.user_id WHERE order.id = 1</b></p>
<p>结果分析：order为驱动表，user表的JOIN列是拆分键，一个order只有唯一一个user。</p>
<p><b>SELECT* FROM user JOIN<br />
order ON user.user_id = order.buyer_id WHERE user.id = 1</b></p>
<p>结果分析：user为驱动表，并且带了拆分键上的等值条件，order表的JOIN列不是拆分键，对于order表是全表扫描。</p>
<p><b>SELECT* FROM user_oders<br />
JOIN order ON user_oders.order_id = order.order_id WHERE user_oders.user_id = 1</b></p>
<p>结果分析：user_orders记录了一个用户有哪些订单，拆分键为user_id，user_oders表为驱动表，并且带了拆分键上的等值条件，order表的JOIN列是拆分键，一个user对应的order会随业务的增长而增长，在order表做的IN查询也会增长。</p>
<h1><b>买卖家问题</b></h1>
<p>具体场景是：一个订单，包含买家id（buyer_id）与卖家id（seller_id），买家希望根据买家来查，而卖家则希望根据卖家来查。那么一张表通过买家来拆还是通过卖家来拆？</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2Q0MGY3ZTExMGY0ZjEwYWU2ZDc3NWJmMTVhMTNhMTc1M2FjOTI2MjMucG5n.jpg"></p>
<p>传统的解法是空间换时间，模仿单机数据库中建索引的这种方式，将数据存两份，一份按买家id拆分，一份按照卖家id拆分。这个方案的缺点是占的空间太大，因为把整个表都冗余起来了。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2M3ZjYwOGUxNDk1MDk0NDBmNTg2YmU4Mzg0MjNhNGI3MWRlYjhjNWQucG5n.jpg"></p>
<p>或许有人认为，一种较好的解决方案是只冗余id列，只需要买家id到卖家id的映射关系和卖家id到买家id的映射关系。在JOIN查询时，随着时间发展，一个买家对应的卖家会越来越多，那么这就是一个错误的方案。更好的方案是把关联关系做一个全冗余，使其避免出现这样的JOIN查询，用更多的空间来换取时间、线性扩展的能力。</p>
<h1><b>DRDS</b></h1>
<p>如何快速判断一个正在使用DRDS的系统是否能做到线性扩展？在DRDS监控页面里面有两个监控指标，一个是物理QPS，一个是逻辑QPS。判断的方法是，看这两个指标是否接近1：1。如果接近1:1说明系统很大概率是可以线性扩展的。若远远大于1:1，那么就不能线性扩展。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 08:54:45</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%ad%98%e5%82%a8/" title="存储">存储</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e5%ba%93/" title="数据库">数据库</a>, <a href="https://www.iamivan.net/tag/sql/" title="sql">sql</a>, <a href="https://www.iamivan.net/tag/%e5%88%86%e5%b8%83%e5%bc%8f/" title="分布式">分布式</a>, <a href="https://www.iamivan.net/tag/drds/" title="DRDS">DRDS</a>, <a href="https://www.iamivan.net/tag/%e5%88%86%e5%b8%83%e5%bc%8f%e6%95%b0%e6%8d%ae%e5%ba%93/" title="分布式数据库">分布式数据库</a>, <a href="https://www.iamivan.net/tag/%e7%ba%bf%e6%80%a7%e6%89%a9%e5%b1%95/" title="线性扩展">线性扩展</a>, <a href="https://www.iamivan.net/tag/%e5%88%86%e5%b8%83%e5%bc%8fjoin/" title="分布式JOIN">分布式JOIN</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>分布式数据库——从线性扩展谈分布式JOIN的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MW201qb.html" rel="bookmark">thinkphp 3&period;2分布式数据库读写分离扩展阅读</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				        thinkphp 3.2分布式数据库读写分离扩展阅读        ThinkPHP内置了分布式数据库的支持,包括主从式数据库的读写分离,但是分布式数据库必须是相同的数据库类型.         配置DB_DEPLOY_TYPE 为1 可以采用分布式数据库支持.如果采用分布式数据库,定义数据库配置信息的方式如下:            //分布式数据库配置定义            'DB_DEPLOY_TYPE'=&gt; 1, // 设置分布式数据库支持            'D			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mq8K9Kb.html" rel="bookmark">云时代的分布式数据库：阿里分布式数据库服务DRDS</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				摘要:伴随着系统性能.成本及扩展性的新时代需要,以HBase.MongoDB为代表的NoSQL数据库和以阿里DRDS.VoltDB.ScaleBase为代表的分布式NewSQL数据库如雨后春笋般不断涌现出来.本文详细介绍了阿里分布式数据库服务DRDS. 随着互联网时代的到来,计算机要管理的数据量呈指数级别地飞速上涨,而我们却完全无法对用户数做出准确预估.我们的系统所需要支持的用户数,很可能在短短的一个月内突然爆发式地增长几千倍,数据也很可能快速地从原来的几百GB飞速上涨到了几百个TB.如果在这爆			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5o3Bnb.html" rel="bookmark">云时代的分布式数据库：阿里分布式数据库服务 DRDS</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				随着互联网时代的到来,计算机要管理的数据量呈指数级别地飞速上涨,而我们却完全无法对用户数做出准确预估.我们的系统所需要支持的用户数,很可能在短短 的一个月内突然爆发式地增长几千倍,数据也很可能快速地从原来的几百GB飞速上涨到了几百个TB.如果在这爆发的关键时刻,系统不稳定或无法访问,那么对 于业务将会是毁灭性的打击. 伴随着这种对于系统性能.成本以及扩展性的新需要,以HBase.MongoDB为代表的NoSQL数据库和以阿里DRDS.VoltDB.ScaleBase为代表的分布式NewSQL数据			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqALjaM.html" rel="bookmark">Amoeba：开源的分布式数据库Porxy解决方案</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				基于此可以实现负载均衡.读写分离.高可用性等需求.与MySQL官方的MySQL Proxy相比,作者强调的是amoeba配置的方便(基于XML的配置文件,用SQLJEP语法书写规则,比基于lua脚本的MySQL Proxy简单). Amoeba相当于一个SQL请求的路由器,目的是为负载均衡.读写分离.高可用性提供机制,而不是完全实现它们.用户需要结合使用MySQL的 Replication等机制来实现副本同步等功能.amoeba对底层数据库连接管理和路由实现也采用了可插拨的机制,第三方可以开发更			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ba7OLnp.html" rel="bookmark">分布式数据库的存储设计改进</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  分布式数据库的存储设计改进       目录 背景... 4 核心思想... 5 负载情况... 5 数据分布规则... 7 基本均衡策略... 8 列表... 8 范围... 9 取余(节点数为除数,即除以节点数取余数) 9 基本均衡策略的分析... 10 基本均衡策略下的数据重新分布... 11 组合均衡策略... 13 两个基本均衡策略的组合... 13 三个基本均衡策略的组合... 15 数据动态重新分布... 19 场景... 19 业务影响分析... 20 如何处理数据重新分布.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0nA68z.html" rel="bookmark">细说分布式数据库的过去、现在与未来</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				主题简介: 分布式数据库的历史和现状 TiDB架构和特点 分布式数据库未来趋势   随着大数据这个概念的兴起以及真实需求在各个行业的落地,很多人都热衷于讨论分布式数据库,今天就这个话题,主要分为三部分:第一部分讲一下分布式数据库的过去和现状,希望大家能对这个领域有一个全面的了解:第二部分讲一下TiDB的架构以及最近的一些进展:最后结合我们开发TiDB过程中的一些思考讲一下分布式数据库未来可能的趋势.   一.分布式数据库的历史和现状       1.从单机数据库说起   关系型数据库起源自197			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKqV2np.html" rel="bookmark">分布式数据库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 分布式数据库领域CAP理论 Consistency(一致性), 数据一致更新,所有数据变动都是同步的 Availability(可用性), 好的响应性能 Partition tolerance(分区容错性) 可靠性,A single piece of data is stored in 3 nodes, 1 node failed, the other 2 nodes can still work. This is implemented via Replication or Duplic			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mr5rKvb.html" rel="bookmark">Hadoop白皮书&lpar;2&rpar;：分布式数据库HBase简介</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				HBase 是一个面向列的分布式数据库.HBase 不是一个关系型数据库,其设计目标是用来解决关系型数据库在处理海量数据时的理论和实现上的局限性.传统关系型数据库在上世纪七十年代为交易系统设计,以满足数据一致性 (ACID)为目标,并没有考虑数据规模扩大时的扩展性,以及单点系统失效时的可靠性.虽然经过多年的技术发展,产生了一些对关系性数据库的修补(并行数据库),然而受限于理论和实现上的约束,扩展性从来没有超过 40 个服务器节点.而 HBase 从一开始就是为 Terabyte 到Petabyt			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/PdzZobn.html" rel="bookmark">传统应用层逻辑分库DB迁移阿里云DRDS&plus;RDS分布式数据库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				随着互联网快速发展,我们的结构化关系数据库在高并发.海量数据的情况下面临单机扩展性问题,首先是单机数据库容量瓶颈,单机数据库在业务高速增长的情况下依赖硬件升级也会到达天花板,并且使用成本变得非常高,而且扩展性的复杂性也是比较高,传统数据库扩容往往意味着服务中断,很难做到业务无感知或者少感知.     通过数据水平切换来现实分库可以帮助提升数据库整体性能.横向扩展性,切分后有效的降低了单台机器的访问负载,同时最大限度的降低了数据库服务节点宕机后的损失.      传统应用业务层逻辑或组件分库实现方			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qzDQPBb.html" rel="bookmark" class="title">PHP从零单排（十四）数据分页显示的原理及实现</a>
					<div>
						ID Name Sex Age &lt;?php echo $row['id']; ?&gt; &lt;?php echo $row['name']; ?&gt; &lt;?php echo $row ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7M0yo0p.html" rel="bookmark" class="title">让ASP提高执行速度</a>
					<div>
						速度|执行     技巧之一:提高使用Request集合的效率 访问一个ASP集合来提取一个值是费时的.占用计算资源的过程.因为这个操作包含了一系列对相关集合的搜索,这比访问一个局部变量要慢得多.因此 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zelEjp.html" rel="bookmark" class="title">PHP控制网页过期时间的程序</a>
					<div>
						有时我们需要控制主页之类的网页过期时间.但我们比如使用的是Chinacache的CDN,那要怎么样设计才能让他缓存我的内容. 有时我们需要控制主页之类的网页过期时间.但我们比如使用的是Chinacac ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB2ykOb.html" rel="bookmark" class="title">高手之路 教你玩转WPS的符号栏</a>
					<div>
						在写文章时经常会用到一些特殊符号,如&quot;§&quot;就经常用到.这个符号有很多方法可以输入,下面我们看一下在WPS中如何输入这个符号. 一.使用符号栏: 1.符号栏的调用: 看一下菜单项&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXB9WWb.html" rel="bookmark" class="title">最简单的字符串算式计算方法</a>
					<div>
						大家都遇到过,计算一个字符串算式的问题,解决起来挺麻烦的.我在一年前想过一个办法,就是连 一下数据库,执行&quot;Select [算式] as Result&quot;,从而得到结果.这几天因对公 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bElye3z.html" rel="bookmark" class="title">Android开发：自动开关机实现教程</a>
					<div>
						  1. 简介 我的实现是在设置程序里面增加一个接口,让用户设置自动开关机,这个自动开关机的设置可以参照闹钟的设置.关于自动关机,考虑到关机的时候,用户可能正有一些重要的操作,那么应该给用户一个机会去 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/balDGqz.html" rel="bookmark" class="title">Photoshop中 模糊锐化和涂抹工具的使用技巧</a>
					<div>
						  在ps的模糊工具内含三个工具--模糊工具.锐化工具.涂抹工具,这三个工具可以对图像的细节进行局部的修饰,下面小编就来告诉你们它们的使用方法及使用效果. photoshop的模糊工具 模糊工具: 一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVnqaQz.html" rel="bookmark" class="title">BAT批处理一键生成APK包脚本分享</a>
					<div>
						  这篇文章主要介绍了BAT批处理一键生成APK包脚本分享,本文脚本适用于cocos2dx+lua的项目,需要的朋友可以参考下 BAT批处理一键生成APK包脚本分享 将本bat放到cocos2dx目录 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNENWyb.html" rel="bookmark" class="title">打开带有视频文件夹慢或无响应怎么办</a>
					<div>
						故障解析:出现这个现象通常可能会有2个原因: A.系统在安装了某些杀毒软件之后出现.部分杀毒软件的实时监控功能,当访问存在体积很大的压缩包或ISO文件的目录时,会自动解压这些文件进行扫描,对于一些配置 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze72NjM.html" rel="bookmark" class="title">简单粗暴创建溶图曝光的海报效果</a>
					<div>
						  简单粗暴创建溶图曝光的海报效果,简单易懂,几步就可以完成,效果也很赞,后四张为素材,有兴趣的可以练习一下,记得交作业啊 分类: PS入门教程					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1E9EdM.html" rel="bookmark" class="title">为word文档自动添加摘要的操作步骤</a>
					<div>
						  点击word文档左上角的office按钮,在下拉菜单中选择右下角的&quot;word选项&quot; 在弹出的&quot;word选项&quot;对话框中,点击左边的&quot;自定义&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkGxD5p.html" rel="bookmark" class="title">Win7系统用注册表加快软件的反应速度的方法</a>
					<div>
						  我们使用的电脑有时候软件会反应速度很慢,甚至出现卡顿的情况,这让一些心急的电脑用户非常苦恼,恨不能把电脑砸了!不过,冲动是魔鬼,想一想电脑也是大几千的玩意,还是冷静一下,来看看小编给大家整理的Wi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvG3gVp.html" rel="bookmark" class="title">打印机驱动程序无法正常安装的解决步骤</a>
					<div>
						由于电脑系统配置以及设置的差异性,打印机类型的多样型,致使打印机驱动无法正常安装也是常有的事.最近小编也遇到此类问题,通过多次尝试,最终成功解决了问题,同时也总结出了相应宝贵的经难事,特此拿来与大家分 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOay9xM.html" rel="bookmark" class="title">ios-PATH  时间轴的问题求大神指点</a>
					<div>
						问题描述 PATH 时间轴的问题求大神指点 你之前在CODE4app发表的那个代码有BUG啊.要怎么解决啊.. IOS8以上有导航栏就不显示滑动条了.http://code4app.com/ios/T ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQr370M.html" rel="bookmark" class="title">jQuery实现随意改变div任意属性的名称和值&lpar;部分原生js实现&rpar;&lowbar;javascript技巧</a>
					<div>
						一些简单的例子,用原生js和jQuery实现随意改变div属性,和重置.代码如下: 复制代码 代码如下: &lt;!DOCTYPE html&gt; &lt;html&gt; &lt;head&gt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDWm5Wp.html" rel="bookmark" class="title">&amp;quot&semi;黑色星期五&amp;quot&semi;阿里云向海淘输出双11技术</a>
					<div>
						本文讲的是&quot;黑色星期五&quot;阿里云向海淘输出双11技术[IT168资讯]11月27日零点,&quot;黑色星期五&quot;正式到来,虽然远在中国的消费者无法参与海外的实体抢购,但电商 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgVAeBb.html" rel="bookmark" class="title">百度推&OpenCurlyDoubleQuote;百度人才&rdquo;插足招聘</a>
					<div>
						值得关注的是,百度的这一招聘栏目还支持从51job.智联.中华英才网三家网站进行简历搬家,即用户直接在&quot;百度人才&quot;中填入上述三家网站的用户名和密码就可以将原来的简历搬家至百度人才中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5N4Vaz.html" rel="bookmark" class="title">JSP include HTML出现乱码 问题解决</a>
					<div>
						Problem? 当使用&lt;jsp:include page=&quot;top.html&quot;&gt;&lt;/jsp:include&gt;引入html文件时, 并且jsp 和 html ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boRAKBz.html" rel="bookmark" class="title">从接口、抽象类到工厂模式再到JVM来总结一些问题</a>
					<div>
						好了,到这里也差不多了,虽然还有很多问题--关键是思想的掌握!   前面提到了,接口不仅是为了避免该类被实例化,只是为了统一规则,而且接口的使用还有一个更加重要的原因是可以使用向上转型!利用接口可以让 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWl7Bqp.html" rel="bookmark" class="title">MongoDB Primary 为何持续出现 oplog 全表扫描？</a>
					<div>
						线上某 MongoDB 复制集实例(包含 Primary.Secondary.Hidden 3个节点 ),Primary 节点突然 IOPS 很高,调查后发现,其中 Hidden 处于 RECOVER ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXqWN5z.html" rel="bookmark" class="title">service-如何在指定的时间取消 PendingIntent？</a>
					<div>
						问题描述 如何在指定的时间取消 PendingIntent? 当我不申明 cancel 时,AlarmManager 能很好的运行.但是当我申明cancel时,也不能取消. Calendar c= C ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmKLQqb.html" rel="bookmark" class="title">美女签名图制作</a>
					<div>
						我们将用photoshop 快速制作出漂亮的美女签名图出来哦,只要你是女生你也可以拥有自己的个性的漂亮的签名哦,只要你看完这篇文章就OK了. 效果图. 区别如何我不多说了现在来看看美教程吧. 上面的签 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZgZG4b.html" rel="bookmark" class="title">python通过ElementTree操作XML获取结点读取属性美化XML&lowbar;python</a>
					<div>
						1.引入库需要用到3个类,ElementTree,Element以及建立子类的包装类SubElement from xml.etree.ElementTree import ElementTreefr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mye36lM.html" rel="bookmark" class="title">关于SUSE10 LINUX定时任务问题【在 线 等，急】</a>
					<div>
						问题描述 公司只能上JE相关的站点.请教个关于LINUX定时器的问题.想要在每天某个时间点,比如每天15点执行一个shell脚本,查了下,0 15 * * * su - cly -c &quot;sh ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmBmODz.html" rel="bookmark" class="title">牛腩新闻发布系统总结（三）----点滴知识</a>
					<div>
						           这篇博客呢主要是讲一下我在做系统的过程中积累下来的感觉很常用但之前没接触过或者有些难理解的地方,与大家分享:       首先,说一下CSS+Div,这个内容在CSS+DIV这篇 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeo94VM.html" rel="bookmark" class="title">最新诈骗手段 网购的货直达骗子手中</a>
					<div>
						浙大研究生小张省吃俭用了一年,终于在网上订到了时下最潮的诺基亚920手机.这手机,价值5000多元呢. 小张和卖家之间是通过http://www.aliyun.com/zixun/aggregatio ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Rkxqz.html" rel="bookmark" class="title">实战百度被K到重新收录</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 我给大家讲述我的小站被百度K了以后 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBgNGNM.html" rel="bookmark" class="title">JAVA 2学习指南  学习笔记---------第一章 语言基础知道</a>
					<div>
						JAVA中的关键字都是小写的.共有49个关键字,2个未使用的保留字:const goto; 数据类型: boolean    byte   int    short   long    float   ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn8xNKb.html" rel="bookmark" class="title">Hotmail更名为Outlook 凸显微软云计算战略</a>
					<div>
						据国外媒体报道,美国当地时间周二,微软推出一项免费的.基于网络的电子邮件门户服务Outlook.com,同时将逐步淘汰Hotmail服务.微软希望把这个新功能建在基于Web的Outlook客户端软件中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ1xNwb.html" rel="bookmark" class="title">不一样的三一重工：重在选择 &mdash;&mdash; 三一集团CIO潘睿刚专访系列之一</a>
					<div>
						&quot;品质改变世界&quot;!这个信念让一家生于湖南涟源的机械制造企业誉满全球.自1994年成立以来,三一重工以年均50%以上速度增长,目前已经发展为中国最大.全球第五的工程机械制造商,也是全 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
